
unit SrcEdTst;

interface


uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, SrcEdit, Clipbrd, Buttons, EditReel;

type
  Tecran = class(TForm)
    Panel1: TPanel;
    ChkModifs: TCheckBox;
    Button0: TButton;
    btnBlocNote: TButton;
    btnMinMaj: TButton;
    Button1: TButton;
    Button2: TButton;
    Button5: TButton;
    Button3: TButton;
    Button4: TButton;
    procedure FormCreate(Sender: TObject);
    procedure EditChange(Sender: TObject);
    procedure Button0Click(Sender: TObject);
    procedure btnBlocNoteClick(Sender: TObject);
    procedure EditMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure btnMinMajClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button5Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure EditMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
  private { Dclarations prives }
    Edit: TSrcEdit;
    Function AskUndo(Sender :TObject):Boolean;
  public  { Dclarations publiques }
  end;

var
  Ecran: Tecran;

implementation

{$R *.DFM}

procedure Tecran.FormCreate(Sender: TObject);
begin
  Edit:=TSrcEdit.Create(Self);
  Edit.Color:=clNavy;
  Edit.Font.Color:=clSilver;
  Edit.parent:=Self;
  Edit.Align:=alClient;
  Top:=0;
  Height:=Screen.Height;
  Left:=100;
  Width:=800;
  Edit.OnChange:=EditChange;
  Edit.OnCannotUndo:=AskUndo;
  Edit.OnMouseDown:=EditMouseDown;
  Edit.OnMouseMove:=EditMouseMove;
  Edit.OnClick:=EditChange;
  Edit.OemFile:=True;
end;

procedure Tecran.FormShow(Sender: TObject);
begin
  edit.SetFocus;
end;

//--------------------------------------------------------------------------

procedure Tecran.Button0Click(Sender: TObject);
begin
  Edit.LoadFromFile('c:\autoexec.bat');
  Edit.SetFocus;
end;

procedure Tecran.Button1Click(Sender: TObject);
begin
  Edit.LoadFromFile('Test0.asm');
  Edit.SetFocus;
end;

procedure Tecran.Button2Click(Sender: TObject);
begin
  Edit.LoadFromFile('...\PP\2031\2031.ASM');
  Edit.SetFocus;
end;

procedure Tecran.Button5Click(Sender: TObject);
begin
  Edit.LoadFromFile('tabgen2.alf');
  Edit.SetFocus;
end;

//--------------------------------------------------------------------------

procedure Tecran.btnBlocNoteClick(Sender: TObject);
begin
  Clipboard.SetTextBuf('Texte copi'#13#10'dans le'#13#10'presse-papier'#13#10#13#10);
  Edit.PasteFromClipboard;
  Edit.SetFocus;
end;

procedure Tecran.btnMinMajClick(Sender: TObject);
begin
  Edit.MinMaj;
  Edit.SetFocus;
end;

//--------------------------------------------------------------------------

procedure Tecran.EditChange(Sender: TObject);
begin
  ChkModifs.Checked:=Edit.Modified;
  Caption:=IntToStr(Edit.SelStart);
end;

Function Tecran.AskUndo(Sender :TObject):Boolean;
Begin
  Result:=MessageDlg('Ne pourra pas tre annul'#13#10'Continuer ?',mtWarning,[mbOk,mbCancel],-1)=mrOk;
End;

procedure Tecran.EditMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  If Button=mbRight then
    Caption:=Edit.MotSousCurseur;
end;

procedure Tecran.EditMouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
begin
  If ssRight in shift then
    Caption:=Edit.MotSousCurseur;
end;

Var SelStart,SelLength:Integer;

procedure Tecran.Button3Click(Sender: TObject);
begin
  SelStart:=Edit.SelStart;
  SelLength:=Edit.SelLength;
end;

procedure Tecran.Button4Click(Sender: TObject);
begin
  Edit.SelStart:=SelStart;
  Edit.SelLength:=SelLength;
  Edit.SetFocus;
end;

end.
