{*****************************************}
{    TSrcEdit Editeur tabul              }
{    Ralisation : Pascal Peyremorte      }
{                                         }
{    p.peyremorte@dial.oleane.com         }
{*****************************************}

{ ../../99  V0.00    Premire construction}

(* Pour Info ---------------------------------

Touches gres :

* Flches Up, down, left, right
* PageUp      : un cran plus haut ; avec Shift : Slection
* PageDown    : un cran plus bas  ; avec Shift : Slection
* Home        : Dbut de la ligne
* End         : Fin de la ligne
* Ctrl-Home   : Premire ligne du fichier
* Ctrl-End    : dernire ligne du fichier
Prcdentes avec shift : slection

Ctrl-Up       : dcalage cran 1 ligne vers bas
Ctrl-Down     : dcalage cran 1 ligne vers haut

Ins           : mode Insertion/Remplacement
Del           : suppression
Back-space    : correction

Ctrl-C / Ctrl-Ins  : Copie slection dans clip board
Ctrl-X / Shift-Del : Coupe slection
Ctrl-V / Shift-Ins : Coller  partir du clipboard
Ctrl-Z / Alt-Back. : undo

Ctrl-Y        : Supprime la ligne sous curseur

Ctrl-K + 1  9 : pose/ote marqueur
Ctrl-Q + 1  9 : va  marqueur

Souris :
  Dplacement curseur,
  Slection avec Shift,
  Slection mot (double-click}

--- Procedures - vennements ---

OnCannotUndo :
  Appele si opration impossible  stocker dans buffer Undo.
  Doit retourner TRUE si accepte de continuer, FALSE sinon.

MotSousCurseur : Retourne le mot sour le curseur SOURIS

MinMaj : Bascule Minuscules <-> Majuscules de la slection ou
         du caractre aprs le curseur si pas de slection.
         PAS OPERATIONEL, EN COURS...
*)

unit SrcEdit;

interface

Uses Windows, Messages, SysUtils, Classes, Controls, Graphics,
     ExtCtrls, Forms, StdCtrls, Clipbrd, Dialogs;
{Attention  l'ordre des dclarations :
  Windows.TBitMap  = record,
  Graphics.TBitMap = Class() }

Const
  _MaxLignes = MaxLongInt div 16;

Type
  // Je rserve TPoint et X,Y pour coordonnes en PIXELs
  TLinCol = Record
    L, C:Integer; {Colonne, Ligne}
  End;

  {Gestion des tabulations}
  TTabTabs = Array[0..100] of Integer; {Tabulations en pixels}
  PTabTabs = ^TTabTabs;

  {Gestion des annulations}
  PInfoUndo = ^TInfoUndo;
  TInfoUndo = Record
                Prec : PInfoUndo; {Entre undo prcdente}
                Lieu : TLinCol;   {Point de rfrence}
                Long : Integer;   {Nombre de caractres ajouts}
                Ref  : Array[0..100000] of char;  {Chaine supprime + #0}
              End;
  TNotifyUndo = Function(Sender:TObject):Boolean of Object;

  {Search and replace}
  TFindProc  = Function(Lig,Col:Integer):Boolean of Object;

  {Gestion du texte}
  TAttrLigne = (ilModif, ilRem, ilMacro, ilCond);
  TIndics    = Set Of TAttrLigne;

  TInfoLigne=Record
           S     :String;   {La chaine}
           NumOrg:Integer;  {Son numro de ligne original dans le fichier}
           Indic :TIndics;  {Indicateurs pour syntaxe et divers}
         End;
  TTabLignes=Array[0.._MaxLignes] of TInfoLigne;
  PTabLignes=^TTabLignes;

  TSrcEdit = Class(TCustomControl)
  Private
    {Aspect, taille}
    fBorderStyle : TBorderStyle;
    fScrollBars  : TScrollStyle;

    fCoulMarge : TColor;         {    Couleur de la marge}
    fLargMarge : Integer;        {Pix largeur de la marge, 0 la cache}
    fMargeG    : Integer;        {Pix Marge gauche du texte = fLargMarge + n}

    fLimite    : Integer;        {Car Position ligne de marge droite, 0 la cache}

    fNbreLig   : Integer;        {Car Nombre de ligne de la fentre}
    fNbreCol   : Integer;        {Car Nombre de colones de la fentre}
    fPremLig   : Integer;        {Car N premire ligne affiche}
    fPremPix   : Integer;        {Pix N premire colonne affiche en pixels}
    fLargTexte : Integer;        {Car Longueur de la plus longue ligne}

    {Dessin de l'cran}
    fDebZone   : Integer;        {Premire caractre  redessiner}
    fFinZone   : Integer;        {Dernire caractre  redessiner}

    {Police caractes et tabulations}
    fTabMax    : Integer;        {Numro dernire tabulation active}
    fPTabs     : PTabTabs;       {Pointeur sur table des tabulations en PIXELS}
    fInterligne: Integer;        {Pix Interligne}
    fLargCar   : Integer;        {Pix Largeur d'un caractre}

    {Gestion du curseur}
    fCaretX    : Integer;        {Pix Position du curseur texte}
    fCaretY    : Integer;        {Pix idem}
    fCaretXMem : Integer;        {Mmoire position curseur pendant ligne courte}
    fCur       : TLinCol;        {Car Ligne du curseur dans le texte}

    {Souris}
    fMouseDown : Boolean;        {Indicateur pour ignore MouseMove sans MouseDown}
    fDbleClick : Boolean;        {Indicateur pour ignorer second click}

    {Clavier}
    fDebCmde   : Char;           {Indicateur dbut commande  2 caractres}
    fInsertion : Boolean;        {Indicateur insertion / remplacement}

    {Gestion du texte}
    fTxt       : PTabLignes;     {Pointeur vers les infos lignes}
    fCount     : Integer;        {Nombre de lignes utilises}
    fTaille    : Integer;        {Nombre de lignes alloues}
    fConvDos   : Boolean;        {Indique fichier est en caractres dos-oem}

    fReadOnly  : Boolean;        {Autorisation de modifications}
    fModified  : Boolean;        {Indicateur de modifications}
    fOnChange  : TNotifyEvent;   {Procdure utilisateur appele sur modifs}

    {Slection et marques}
    fClick     : TLinCol;        {Car Pos Curseur au dbut de def d'un bloc}
    fDebSel    : TLinCol;        {Car Ligne de la fin de slection, -1 si rien}
    fFinSel    : TLinCol;        {Car N caractre fin de slection}
    fCoulTxtSel: TColor;         {Couleur du texte de la slection}
    fCoulFndSel: Tcolor;         {Couleur du fond de la slection}

    fMarques   : Array[0..9] of TLinCol; {Marqueurs pour accs rapide}

    {Undo}
    fTailleUndo: Integer;        {Taille du buffer Undo}
    fPBufUndo  : PInfoUndo;      {Ptr sur buffer enregistement infos Undo}
    fPUndo     : PInfoUndo;      {Ptr sur dernire info Undo entre}
    fRetOrigin : Boolean;        {Retour  original possible : BufUndo pas dbord}
    fOnRazUndo : TNotifyUndo;    {Fonction appele si info Undo impossible  sauver}

    {Aspect, taille, messages}
    Procedure CreateParams(var Params:TCreateParams); Override;
    Procedure SetBorderStyle(Style:TBorderStyle);
    Procedure WMSize(var Msg:TWMSize); Message WM_Size;

    {Dessin de l'cran}
    Procedure WMEraseBkGnd(var Msg:TMessage); Message WM_EraseBkGnd;
    Procedure Paint; Override; {Reaffichage de tout l'cran}
    Procedure PaintZone;  {Raffichage de fDebZone  fFinZone, marge + texte}
    Procedure PaintFinPage;
    Procedure TraceMarge; {Trace marge gauche entre fDebZone et fFinZone}
    Procedure TraceTexte; {Trace texte entre fDebZone et fFinZone uniquement}
    Procedure InitZone(Ligne:Integer); {La zone est une seule ligne}
    Procedure InitZoneSel;{La zone  peindre est la slection}
    Procedure AgranditZone(Ligne:Integer);

    {Polices, Caractres et Tabulations}
    Procedure MesureCars;
    Procedure SetFont(Police:TFont);
    Function  ProchaineTab(X:Integer):Integer;
    Function  PixelToCar(Pix:Integer; Const S:String):Integer;
    Function  GetTabPix(N:Integer):Integer; {Accs  proprit TabPix}
    Procedure SetTabPix(N,Valeur:Integer);  {idem}
    Function  GetTabCar(N:Integer):Integer; {Accs  proprit TabCar}
    Procedure SetTabCar(N,Valeur:Integer);

    {Focus et Curseur texte = Caret}
    Procedure WMSetFocus (var Msg:TWMSetFocus);  message WM_SETFOCUS;
    Procedure WMKillFocus(var Msg:TWMKillFocus); message WM_KILLFOCUS;
    Function PosCurChange(Recadre:Bool):Boolean;  {Retourne True si doit redessiner cran}
    Procedure SetLineIndex(N:Integer);
    Procedure SetColIndex(N:Integer);

    {Dcalages}
    Procedure SetScrollStyle(Style:TScrollStyle);
    Procedure MajScrollBars;
    Procedure WMHScroll(var Msg:TWMScroll); Message WM_HSCROLL;
    Procedure WMVScroll(var Msg:TWMScroll); Message WM_VSCROLL;
    Procedure SetPremLig(PremLig:Integer);

    {Actions souris}
    Procedure MouseDown(Button:TMouseButton; Shift:TShiftState; X,Y:Integer); Override;
    Procedure MouseMove(Shift:TShiftState; X,Y:Integer); Override;
    Procedure MouseUp(Button:TMouseButton; Shift:TShiftState; X,Y:Integer); Override;
    Procedure DblClick; Override;

    {Actions Clavier}
    Procedure WndProc(var msg: TMessage); Override;
    Procedure WMGetDlgCode(var Msg:TWMGetDlgCode); message WM_GETDLGCODE;
    Procedure KeyDown(var Key:Word; Shift:TShiftState); Override;
    Procedure KeyPress(var Key:Char); Override;

    {Gestion du texte}
    Procedure SignaleModif; {Pour appeller OnChange si autoris}
    Function  GetLine(N:Integer):String;                {Retourne la ligne N}
    Procedure SetLine(N:Integer; Const Chaine:String);  {Remplace la ligne N}
    Function  GetBlocTexte(LigDeb,ColDeb, LigFin,ColFin:Integer):String;
    Procedure InsBlocTexte(VAR Lig,Col:Integer; Chaine:String);
    Function  GetTexte:String;
    Procedure SetTexte(Chaine:String);

    {Slection et marques}
    Procedure CreeSelection;
    Procedure AnnuleSelection;
    Function  GetSelStart:Integer;
    Procedure SetSelStart(N:Integer);
    Function  GetSelLength:Integer;
    Procedure SetSelLength(N:Integer);
    Function  GetTexteSel:String;
    Procedure SetTexteSel(const Chaine:String);
    Procedure MajMarques(Const Ote,Rempl:String; Ou:TLinCol);

    {Undo}
    Function AjInfoUndo(Const Ote,Rempl:String; Ou:TLinCol):Boolean;

  Public
    Constructor Create(AOwner:TComponent); Override;
    Destructor Destroy; Override;

    {Gestion du texte}
    Property  Count:Integer read fCount;
    Property  Lines[N:Integer]:String read GetLine write SetLine;
    Property  Text:String read GetTexte write SetTexte;

    Procedure InsLine(N:Integer; Const Chaine:String);  {Insre avant la ligne N}
    Procedure DelLine(N:Integer);                       {Supprime la ligne N}
    Property  LineIndex:Integer read fCur.L write SetLineIndex; // Numro de ligne du curseur de 0  Count-1
    Property  ColIndex :Integer read fCur.C write SetColIndex;  // Numro de colonne  de 1  Length(CLigne);

    Function SelAvail:Boolean;
    Property SelText:String read GetTexteSel write SetTexteSel;
    Property SelStart:Integer read GetSelStart write SetSelStart;
    Property SelLength:Integer read GetSelLength write SetSelLength;

    Procedure LoadFromFile(NomFich:TFileName);
    Function SaveToFile(NomFich:TFileName):Boolean;

    Function  CanUndo:Boolean;
    Procedure Undo;

    {Gestion caractres et tabulations}
    Property  CarWidth:Integer read fLargCar;
    Procedure SetTabsCar(Table:Array of Word); {init toutes les tabs}
    Property TabsPix[N:Integer]:Integer read GetTabPix write SetTabPix;
    Property TabsCar[N:Integer]:Integer read GetTabCar write SetTabCar;

    {Fonction "standard"}
    Procedure CopyToClipboard;
    Procedure CutToClipboard;
    Procedure PasteFromClipboard;
    Property  FirstVisibleLine:Integer read fPremLig write SetPremLig;
    Procedure MontreLigne(N:Integer);

    {Fonctions de traitement du texte}
    Function MotSousCurseur:String;
    procedure MinMaj;
    Function Search(Chaine:String; Options:TFindOptions; Proc:TFindProc):Boolean;
  Published
    Property Align;
    Property BorderStyle: TBorderStyle read fBorderStyle write SetBorderStyle default bsSingle;
    Property Color;  {Couleur du fond de l'diteur}
    Property Ctl3D;
    property Cursor default crIBeam;
    Property DragCursor;
    Property DragMode;
    Property Enabled;
    Property Font write Setfont;
// HideSelection;
    Property Modified:Boolean read fModified write fModified default False;
    Property OemFile:Boolean read fConvDos write fConvDos default False;
    Property ParentColor;
    property ParentCtl3D;
    Property ParentFont;
    Property ParentShowHint;
    property PopupMenu;
    Property ReadOnly:Boolean read fReadOnly write fReadOnly default false;
    Property ScrollBars:TScrollStyle read fScrollBars write SetScrollStyle Default ssBoth;
    Property ShowHint;
    Property TabOrder;

    Property TabStop default True;
    Property Visible;

    Property OnCannotUndo : TNotifyUndo read fOnRazUndo write fOnRazUndo;
    Property OnChange:TNotifyEvent read fOnChange Write fOnChange;
    Property OnEnter;
    Property OnExit;

    Property OnKeyDown;
    Property OnKeyPress;
    Property OnKeyUp;

    Property OnMouseDown;
    Property OnMouseMove;
    Property OnMouseUp;
    Property OnClick;
    Property OnDblClick;

    Property OnStartDrag;
    Property OnEndDrag;
    Property OnDragOver;
    Property OnDragDrop;
  End;

Procedure Register;

implementation

Var
  Marques : Array[0..9] of TBitMap;

Procedure Register;
Begin
  RegisterComponents('Perso',[TSrcEdit]);
End;

//--------------------------------------------------------------------------
// Quelques outils globaux hors objet
//--------------------------------------------------------------------------

Function Min(X, Y:Integer):Integer;
Asm
  cmp eax,edx
  jl  @Fin
  mov eax,edx
@Fin:
End;

{Foce X  rester dans la plage [0,Max] avec Max>=0}
Procedure Limite0Max(Var X:Integer; Max:Integer);
Begin
  If X>Max then X:=Max;
  If X<0 then X:=0;
End;

Function MemeCoord(CONST X,Y:TLinCol):Boolean;
Asm
  mov ecx,TLinCol[eax].L
  cmp ecx,TLinCol[edx].L
  jne @Diff
  mov ecx,TLinCol[eax].C
  cmp ecx,TLinCol[edx].C
  jne @Diff

  mov eax,True
  ret
@Diff:
  xor eax,eax {false}
End;

{Retourne le nombre de CR de la chane S
 et place dans Col la longueur de la dernire ligne de S}
Function NbrLigCol(S:String; Var Col:Integer):Integer;
Var D,P:PChar;
Begin
  Result:=0;
  P:=PChar(S);
  D:=P;
  While P^<>#0 do
  Begin
    If P^=#13 then
    Begin
      Inc(Result);
      If P[1]=#10 then
        Inc(P);
      D:=P;
    End;
    Inc(P);
  End;
  Col:=P-D-1;
End;

//--------------------------------------------------------------------------
// Cration / Destruction / Taille / Aspect
//--------------------------------------------------------------------------

Constructor TSrcEdit.Create(AOwner: TComponent);
Begin
  Inherited Create(AOwner);
  Width:=185;
  Height:=89;
  
  fTaille:=100;
  fTxt:=AllocMem(fTaille*SizeOf(TInfoLigne));
  fCount:=1;

  fTabMax:=5;
  GetMem(fPTabs, (fTabMax+1)*SizeOf(Integer));
  fPTabs^[0]:=112;
  fPTabs^[1]:=184;
  fPTabs^[2]:=328;
  fPTabs^[3]:=384;
  fPTabs^[4]:=440;
  fPTabs^[5]:=560;

  fCoulMarge:=clBtnFace;
  fLargMarge:=17;         {2(Marge)+11(bitmap)+2(marge)+ 2(Lignes)= 17 pixels hors tout pour la marge}
  fLargTexte:=120;        {120 caractres pour la largeur du texte METTRE PIXELS}
  fMargeG:=fLargMarge+8;  {Marge entre texte et bord contrle}
  fLimite:=80;
  fScrollBars:=ssBoth;

  BorderStyle:=bsSingle;
  Font.Name:='Courier New';
  Font.Size:=10;
  MesureCars; {Initialise fLargCar et fInterligne}
  Cursor:=crIBeam;
  fCoulFndSel:=clSilver;
  fCoulTxtSel:=clNavy;

  fPremLig:=0;
  fPremPix:=0;

  fCaretX:=fMargeG;
  fCaretY:=0;
  fCaretXMem:=-1;
  fCur.L:=0;
  fCur.C:=1;
  fClick:=fCur;
  fDbleClick:=false;
  fMouseDown:=false;
  AnnuleSelection;
  fInsertion:=True;

  fDebCmde:=#0; {Pas de commande en cours}
  FillChar(fMarques, sizeof(fMarques), -1);

  fTailleUndo:=32768;            {Taille par dfaut}
  GetMem(fPBufUndo,fTailleUndo); {Rserve place pour buffer undo}
  fPUndo:=Nil;                   {Initialise pointeur}
  fRetOrigin:=True;              {Il est possible de retourner  l'tat initial}
  fOnRazUndo:=Nil;               {on ne pose pas de questions...}

  fOnChange:=Nil;

  TabStop:=True;
End;

Destructor TSrcEdit.Destroy;
Begin
  FreeMem(fTxt, fTaille*SizeOf(TInfoLigne));
  FreeMem(fPTabs);
  FreeMem(fPBufUndo);
  Inherited Destroy;
End;

Procedure TSrcEdit.CreateParams(var Params:TCreateParams);
Const
  ScrollBar   : Array[TScrollStyle] of DWORD=(0,WS_HSCROLL,WS_VSCROLL,WS_HSCROLL or WS_VSCROLL);
  BorderStyles: Array[TBorderStyle] of DWORD=(0,WS_BORDER);
Begin
  Inherited CreateParams(Params);
  With Params do
  Begin
    Style:=Style or ScrollBar[fScrollBars]
                 or BorderStyles[fBorderStyle]
                 or WS_CLIPCHILDREN
                 or WS_EX_TRANSPARENT;

    If NewStyleControls and Ctl3D and (fBorderStyle=bsSingle) then
    Begin
      Style:=Style and not WS_BORDER;
      ExStyle:=ExStyle or WS_EX_CLIENTEDGE;
    End;
  End;
End;

Procedure TSrcEdit.SetBorderStyle(Style:TBorderStyle);
Begin
  If fBorderStyle<>Style then
  Begin
    fBorderStyle:=Style;
    RecreateWnd;
  End;
End;

procedure TSrcEdit.WMSize(var Msg:TWMSize);
begin
  fNbreCol:=(ClientWidth-fMargeG) div fLargCar;
  fNbreLig:=ClientHeight div fInterligne;
  MajScrollBars;
  //  inherited;
end;


Procedure TSrcEdit.WndProc(var Msg:TMessage);
Const Alt=$20000000;
Begin
  Case msg.msg of
    WM_SYSCHAR : // Pour supprimer Beep sur Alt-Backspace
      If (msg.wParam = VK_BACK) and ((msg.lParam and Alt)<>0) then
      Begin
        Undo;
        msg.Msg:=0;
      End;
    else
      Inherited;
  End;
End;


//--------------------------------------------------------------------------
// Affichage
//--------------------------------------------------------------------------

Procedure TSrcEdit.WMEraseBkGnd(var Msg:TMessage);
Var T:TRect;
Begin
  {Remplis la zone entre marge et texte}
  T.Top:=0;
  T.Left:=fLargMarge;
  T.Bottom:=ClientHeight;
  T.Right:=fMargeG;

  Canvas.Brush.Style:=bsSolid;
  Canvas.Brush.Color:=Color;
  Canvas.FillRect(T);

  Msg.Result:=1; //Indique  win qu'effacement a t fait
End;


Procedure TSrcEdit.InitZone(Ligne:Integer);
Begin
  fDebZone:=Ligne;
  fFinZone:=Ligne;
End;

Procedure TSrcEdit.InitZoneSel;
Begin
  fDebZone:=fDebSel.L;
  fFinZone:=fFinSel.L;
End;

Procedure TSrcEdit.AgranditZone(Ligne:Integer);
Begin
  If Ligne<fDebZone then
    fDebZone:=Ligne
  else
    If Ligne>fFinZone then
      fFinZone:=Ligne;
End;

{Redessine Marge et Texte pour les lignes de fDebZone  fFinZone}
Procedure TSrcEdit.PaintZone;
Begin
  If fLargMarge>0 then TraceMarge;
  TraceTexte;
End;

Procedure TSrcEdit.PaintFinPage;
Begin
   fFinZone:=fPremLig+fNbreLig+1;
   PaintZone;
End;

{Surcharge de TCustomControl.Paint pour tout dessiner}
Procedure TSrcEdit.Paint;
Begin
  fDebZone:=fPremLig;
  fFinZone:=fPremLig+fNbreLig+1;

  If fLargMarge>0 then TraceMarge;

  TraceTexte;
End;

//---------------------- DESSIN ------------------------

{Redessine la marge pour les lignes fDebZone  fFinZone inclues}
Procedure TSrcEdit.TraceMarge;
Var
  I  : Integer;
  BM : TBitmap; {Zone de trac temporaire pour viter scinctillements}
  T  : TRect;
    Procedure TraceVerticale(X:Integer; Coul:TColor);
    Begin
      BM.Canvas.Pen.Color:=Coul;
      BM.Canvas.MoveTo(X,0);
      BM.Canvas.LineTo(X,ClientHeight);
    End;
Begin
  BM := TBitmap.Create;
  Try
    BM.Height := ClientHeight;
    BM.Width  := fLargMarge;
    With BM.Canvas do
    Begin
      T.Top:=0;
      T.Left:=0;
      T.Bottom:=ClientHeight;
      T.Right:=fLargMarge-2;

      Brush.Style:=bsSolid;
      Brush.Color:=fCoulMarge;
      FillRect(T);

      Pen.Width:=1;
      TraceVerticale(fLargMarge-2,cl3DLight);
      TraceVerticale(fLargMarge-1,cl3DDkShadow);

      If (fLargMarge>fLargCar+6) then
        For I := 0 to 9 do
          With fMarques[i] do
          If (L>=fPremLig) and (L<fPremLig+fNbreLig) then
              Draw(3,(L-fPremLig)*fInterligne+1,Marques[I]);
      T.Right:=fLargMarge;
      {self.}Canvas.CopyRect(T, BM.Canvas, T);
    End;
  finally
    BM.Free;
  End;
End;

{Redessine les caractres pour les lignes fDebZone  fFinZone inclues}
Procedure TSrcEdit.TraceTexte;
Var
    X,Y : Integer; {Pix Position d'affichage des lignes}
    Lig : Integer; {Numro de la ligne affiche en Y}
    DernLig : Integer; {Numro dernire ligne  afficher}
    S   : String;  {Raccourci pour manipulation chane  afficher}
    L   : Integer; {Nombre caractres chaine entre tabs  afficher}
    F   : Integer;
    R   : TRect;   {pour remplissage des tabulations}
    Lim : Integer; {Position en pixel de la ligne limite}

    {Trace les caractres S[D]  S[F] inclus avec les tabulations}
    Procedure TraceCars(D,F:Integer);
    Begin
      While (D<=F) and (X<=ClientWidth) do
      Begin
        L:=D; {Recherche tabulations}
        Repeat
          If S[L]=#9 then Break;
          Inc(L);
        Until L>F; {L pointe tabulation ou fin de chaine}
        Dec(L,D);
        Canvas.TextOut(X+fMargeG,Y,Copy(S,D,L));
        Inc(X,L*fLargCar);
        Inc(D,L);
        If (X>ClientWidth) or (D>F) then Break;
        {Trace une tabulation}
        R.Left:=X+fMargeG;
        X:=ProchaineTab(X+fPremPix)-fPremPix;
        R.Right:=X+fMargeG;
        Canvas.FillRect(R);
        Inc(D);
      End;
    End;
    {??? A AJOUTER : inutile d'crire au del de ClientWidth}
Begin
  If fDebZone<fPremLig then fDebZone:=fPremLig;
  If (fDebZone>fFinZone) then Exit; {Rien  retracer}

  {Calcule position en pixels de la limite droite, -1 si pas visible}
  If fLimite>0 then
  Begin
    Lim:=fLimite*fLargCar-fPremPix+fMargeG;
    If (Lim<=fMargeG) or (Lim>=ClientWidth) then
      Lim:=-1;
  End
  else
    Lim:=-1;
  Canvas.Pen.Width:=1;

  Canvas.Font.Assign(Self.Font);
  If (fDebZone>fDebSel.L) and (fDebZone<=fFinSel.L) then
  Begin
    Canvas.Brush.Color:=fCoulFndSel;
    Canvas.Font.Color :=fCoulTxtSel;
  End
  else
  Begin
    Canvas.Brush.Color:=Color;
    Canvas.Font.Color :=Font.Color;
  End;

  Y:=(fDebZone-fPremLig)*fInterligne;
  HideCaret(Self.Handle);
  Lig:=fDebZone;
  DernLig:=Min(fFinZone,fCount-1);
  While Lig <= DernLig do
  Begin
    X:=0; {La ligne commence toujours en 0 sur l'cran}
    R.Top:=Y;
    R.Bottom:=R.Top+fInterligne;
    S:=fTxt^[Lig].S;

    If S<>'' then
      If (Lig<>fDebSel.L) and (Lig<>fFinSel.L) then
        {Ligne entirement hors ou dans la slection}
        TraceCars(PixelToCar(fPremPix,S),Length(S))
      else
      Begin {une partie de la ligne est dans la slection}
        If Lig=fDebSel.L then
        Begin
          TraceCars(PixelToCar(fPremPix,S), fDebSel.C-1);
          Canvas.Brush.Color:=fCoulFndSel;
          Canvas.Font.Color :=fCoulTxtSel;
        End;

        If Lig=fFinSel.L
          then F:=fFinSel.C-1
          else F:=Length(S);
        TraceCars(PixelToCar(X+fPremPix,S),F);

        If Lig=fFinSel.L then
        Begin
          Canvas.Brush.Color:=Color;
          Canvas.Font.Color:=Font.Color;
          TraceCars(PixelToCar(X+fPremPix,S),Length(S));
        End;
      End;

    // Remplis espace rsiduel en fin de ligne
    If X<ClientWidth then
    Begin
      R.Left :=X+fMargeG;
      R.Right:=ClientWidth;
      Canvas.FillRect(R);
    End;

    // Trace la ligne de marge droite, plac ici pour limiter scinctillements
    If Lim>=0 then
    Begin
      Canvas.Pen.Color:=clWhite;
      Canvas.MoveTo(Lim,R.Top);
      Canvas.LineTo(Lim,R.Bottom);
    End;

    Inc(Y,fInterligne);
    Inc(Lig);
  End;

  If Lig<fFinZone then
  Begin
    R.Top:=Y;
    R.Bottom:=(fFinZone-fPremLig)*fInterligne;
    R.Left :=fMargeG;
    R.Right:=ClientWidth;
    Canvas.Brush.Color:=Color;
    Canvas.FillRect(R);
  End;

  ShowCaret(Self.Handle);
End;


//--------------------------------------------------------------------------
// Polices, Caractres et Tabulations
//--------------------------------------------------------------------------

Procedure TSrcEdit.MesureCars;
var
  DC:HDC;
  Save:THandle;
  Metrics:TTextMetric;
  LargMax:Integer;
begin
  DC:=GetDC(0);
  Save:=SelectObject(DC,Font.Handle);
  GetTextMetrics(DC,Metrics);
  SelectObject(DC,Save);
  ReleaseDC(0,DC);
  with Metrics do
  begin
    fLargCar:=tmAveCharWidth;
    LargMax :=tmMaxCharWidth;
    fInterligne:=tmHeight+tmExternalLeading;
  end;
  If fLargCar<>LargMax then
    Inherited Font.Pitch:=fpFixed;
end;

procedure TSrcEdit.SetFont(Police:TFont);
Var L,I : Integer;
begin
  L:=fLargCar;           // Conserve largeur caractres actuels
  Inherited Font:=Police;// Met la nouvelle police;

  MesureCars;            // Rcupre nouvelle largeur des caractres
  For I:=0 to fTabMax do
    fPTabs^[I]:=MulDiv(fPTabs^[I],fLargCar,L);
//  Repaint;
end;

{Lit la position d'une tabulation en pixels}
Function TSrcEdit.GetTabPix(N:Integer):Integer;
Begin
  If (N<0) or (N>fTabMax)
    then Result:=-fTabMax    // Retourne le nombre de tabulations
    else Result:=fPTabs^[N]; // Retourne la valeur de la tabulation
End;

{Programme une tabulation en pixels}
Procedure TSrcEdit.SetTabPix(N,Valeur:Integer);
Begin
  If (N<=fTabMax) and (fPTabs^[N]=Valeur) then Exit;

  If N>fTabMax then
    ReallocMem(fPTabs, (N+1)*SizeOf(Integer));

  fPTabs^[N]:=Valeur;
  Repaint;
End;

{Lit la position d'une tabulation en caractres}
Function TSrcEdit.GetTabCar(N:Integer):Integer;
Begin
  If (N<0) or (N>fTabMax)
    then Result:=-fTabMax // Retourne le nombre de tabulations
    else Result:=fPTabs^[N] div fLargCar; // Retourne la valeur de la tabulation
End;

{Programme une tabulation en caractres}
Procedure TSrcEdit.SetTabCar(N,Valeur:Integer);
Begin
  SetTabPix(N, Valeur*fLargCar);
End;

{Programme toutes les tabulations d'un seul coup en caractres}
Procedure TSrcEdit.SetTabsCar(Table:Array of Word);
Var I,Max:Integer;
Begin
  Max:=High(Table);
  If Max>fTabMax then
    ReallocMem(fPTabs, (Max+1)*SizeOf(Integer));

  For I:=Low(Table) to High(Table) do
    fPTabs^[I]:=Table[I]*fLargCar;
  Repaint;
End;

{--- Utilisation interne des tabulations ---}

{Retourne la premire tabulation suivant le pixel X, ou X si pas de tabulations}
Function TSrcEdit.ProchaineTab(X:Integer):Integer;
// eax=Self, edx=X;
Asm
  push ebx

  xchg eax,edx           {X directement dans rsult, Self dans edx}
  mov  ecx,[edx.fTabMax] {Rcupre nombre de tabs}
  jcxz @NoTab
  mov  ebx,[edx.fPTabs]  {Rcupre pointeur sur table tabulations}
@Boucle:
  cmp  eax,[ebx]         {Cette tabulation est aprs X ?}
  jge  @Non              {non, saute}

  mov  eax,[ebx]         {oui, retourne cette valeur}
  jmp  @Fin
@Non:
  add  ebx,4             {Pointe tabulation suivante 4=SizeOf(Integer)}
  dec  ecx               {Il reste des tabulations ?}
  jns  @Boucle           {oui, continue la recherche}
@NoTab:
  add  eax,[edx.fLargCar]{Pas de tab, remplace par espace double}
  add  eax,[edx.fLargCar]
@Fin:
  pop  ebx
End;

// Retourne le numro du caractre du texte S situ sous le pixel Pix
// Retourne 1 si pixel avant la chaine, Length+1 si au dela de la fin
Function TSrcEdit.PixelToCar(Pix:Integer; Const S:String):Integer;
Var X:Integer; {compteur de pixels}
Begin
  X:=0;        {Premier pixel du caractre}
  Result:=1;   {numro du caractre dans la chane}
  If S<>'' then
  Repeat
    If S[Result]=#9
      then X:=ProchaineTab(X)
      else Inc(X,fLargCar);
    If X>Pix then Break;
    Inc(Result);
  until Result>Length(S);
End;


//--------------------------------------------------------------------------
// Activation dsactivation (Focus pris ou perdu}
// et Curseur texte (Caret)
//--------------------------------------------------------------------------

Procedure TSrcEdit.WMSetFocus(var Msg: TWMSetFocus);
begin
  inherited;
  CreateCaret(Handle, 0, 2, fInterligne - 2);
  SetCaretPos(fCaretX, fCaretY);
  ShowCaret(Handle);
  // if FHideSelection and SelAvail then Paint{Selection};
end;

Procedure TSrcEdit.WMKillFocus(var Msg: TWMKillFocus);
begin
  inherited;
  DestroyCaret; {et l'efface de l'cran}
  // if FHideSelection and SelAvail then Paint{Selection};
end;


{Retourne True si l'cran a t dplac et doit tre repaint}
Function TSrcEdit.PosCurChange(Recadre:Bool):Boolean;
Var S:String;
    C:Integer;

    Function CurToPix:Integer;
    Begin
      S:=fTxt^[fCur.L].S;
      Result:=0;    {Premier pixel du caractre}
      C:=1;         {Numro du caractres}
      If S<>'' then
      While C<fCur.C do
      Begin
        If S[C]=#9
          then Result:=ProchaineTab(Result)
          else Inc(Result,fLargCar);
        Inc(C);
      End;
    End;

Begin
  // Impose au curseur de rester dans le texte
  Limite0Max(fCur.L, fCount-1);
  fCur.C:=Min(fCur.C, Length(fTxt^[fCur.L].S)+1);

  Result:=False;
  If Recadre then
  Begin  // Dcale l'cran si le curseur sort de la zone visible
    C:=CurToPix;
    If C<fPremPix then
    Begin
      fPremPix:=C;
      MajScrollBars;
      Result:=True;
    End
    else
      If C+fMargeG+fLargCar-fPremPix>ClientWidth then
      Begin
        fPremPix:=C+fMargeG+fLargCar-(ClientWidth div fLargCar)*fLargCar;
        MajScrollBars;
        Result:=True;
      End;

    If fCur.L<fPremLig then
    Begin
      fPremLig:=fCur.L;
      MajScrollBars;
      Result:=True;
    End
    else
      If fCur.L>=fNbreLig+fPremLig then
      Begin
        fPremLig:=fCur.L-fNbreLig+1;
        MajScrollBars;
        Result:=True;
      End;
  End;

  // Calcule la position en pixels du curseur
  fCaretY:=(fCur.L-fPremLig)*fInterligne;
  fCaretX:=CurToPix-fPremPix+fMargeG;
  If fCaretX>fLargMarge
    then SetCaretPos(fCaretX,fCaretY)
    else SetCaretPos(-5,0);
End;

Procedure TSrcEdit.SetLineIndex(N:Integer);
Begin
  If fCur.L=N then Exit;

  fCur.L:=N;
  fCur.C:=Min(fCur.C, Length(fTxt^[N].S)+1);
  PosCurChange(True);
End;

Procedure TSrcEdit.SetColIndex(N:Integer);
Begin
  If fCur.C=N then Exit;

  If N<1 then
    N:=1
  else
    N:=Min(N, Length(fTxt^[N].S)+1);
  fCur.C:=N;
  PosCurChange(True);
End;


//--------------------------------------------------------------------------
// Gestion des ascenseurs
//--------------------------------------------------------------------------

Procedure TSrcEdit.MajScrollBars;
Var
  ScrollInfo: TScrollInfo;
Begin
  ScrollInfo.cbSize    := SizeOf(ScrollInfo);
  ScrollInfo.nMin      := 0;
  ScrollInfo.nTrackPos := 0;
  ScrollInfo.fMask     := SIF_ALL;

  // Ajuste barre verticale
  If fScrollBars in [ssBoth, ssVertical] then
  Begin
    ScrollInfo.nMax  := fCount-1;
    ScrollInfo.nPage := fNbreLig;
    ScrollInfo.nPos  := fPremLig;
    SetScrollInfo(Handle,SB_VERT,ScrollInfo,True);
    ShowScrollBar(Handle,SB_VERT,True);
  End;

  // Ajuste barre horizontale
  If fScrollBars in [ssBoth, ssHorizontal] then
  Begin
    ScrollInfo.nMax  := fLargTexte+fNbreCol;
    ScrollInfo.nPage := fNbreCol;
    ScrollInfo.nPos  := fPremPix div fLargCar;
    SetScrollInfo(Handle,SB_HORZ,ScrollInfo,True);
    ShowScrollBar(Handle,SB_HORZ,True);
  End;
End;

Procedure TSrcEdit.SetScrollStyle(Style:TScrollStyle);
Begin
  If (FScrollBars <> Style) then
  Begin
    fScrollBars:=Style;
    RecreateWnd;
    MajScrollBars;
    Paint;
  End;
End;

Procedure TSrcEdit.WMHScroll(var Msg:TWMScroll);
Begin
  Case Msg.ScrollCode of
    SB_BOTTOM:      fPremPix:=fLargTexte*fLargCar;     // En bute droite
    SB_ENDSCROLL:   Exit;                              // Pas de dplacement !
    SB_LINELEFT:    Dec(fPremPix,fLargCar);            // 1 car vers gauche
    SB_LINERIGHT:   Inc(fPremPix,fLargCar);            // 1 car vers droite
    SB_PAGELEFT:    Dec(fPremPix,ClientWidth-fMargeG); // 1 cran vers gauche
    SB_PAGERIGHT:   Inc(fPremPix,ClientWidth-fMargeG); // 1 cran vers droite
    SB_THUMBPOSITION,                                  // Suit dplacement
    SB_THUMBTRACK:  fPremPix:=Msg.Pos*fLargCar;
    SB_TOP:         fPremPix:=0;                       // En bute gauche
  End;
  Limite0Max(fPremPix, fLargTexte*fLargCar+ClientWidth-fMargeG);
  MajScrollBars;
  Paint;
  PosCurChange(False);
End;

Procedure TSrcEdit.WMVScroll(var Msg:TWMScroll);
Var PremLig:Integer;
Begin
  PremLig:=fPremLig;
  Case Msg.ScrollCode of
    SB_BOTTOM:      PremLig:=fCount-fNbreLig; // En buts basse
    SB_ENDSCROLL:   Exit;                     // Pas de dplacement !
    SB_LINEDOWN:    Inc(PremLig);             // 1 ligne vers haut
    SB_LINEUP:      Dec(PremLig);             // 1 ligne vers bas
    SB_PAGEDOWN:    Inc(PremLig,fNbreLig);    // 1 page vers haut
    SB_PAGEUP:      Dec(PremLig,fNbreLig);    // 1 page vers bas
    SB_THUMBPOSITION,                         // Suit dplacement
    SB_THUMBTRACK:  PremLig:=Word(Msg.pos);   // Limite = 65536 Lignes
    SB_TOP:         PremLig:=0;               // En bute haute
  End;
  SetPremLig(PremLig);
End;

Procedure TSrcEdit.SetPremLig(PremLig:Integer);
Begin
//  If PremLig<0 then Inc(PremLig,32768); // Limitation du ScrollBar...
  If fPremLig = PremLig then Exit;

  fPremLig:=PremLig;
  Limite0Max(fPremLig, fCount-fNbreLig);
  MajScrollBars;
  Paint;
  PosCurChange(False);
End;


//--------------------------------------------------------------------------
// Gestion de la souris
//--------------------------------------------------------------------------

Procedure TSrcEdit.MouseDown(Button:TMouseButton; Shift:TShiftState; X,Y:Integer);
Begin
  If fDbleClick then
  Begin {Ne fait pas le second click du doubleclick !}
    fDbleClick:=False;
    Exit;
  End;

  Inherited; {Appelle OnMouseDown si dfini}

  fMouseDown := Button=mbLeft;
  If fMouseDown then
  Begin
    InitZone(fCur.L); {Mmorise ligne curseur pour zone  dessiner}

    fCur.L:=Min((Y div fInterligne)+fPremLig,fCount-1); {Fait Trunc() }
    fCur.C:=PixelToCar(X-fMargeG+fPremPix + fLargCar div 2, fTxt^[fCur.L].S);

    If ssShift in Shift then
    Begin {Modification de la slection}
      CreeSelection;
      AgranditZone(fCur.L);
      TraceTexte;
    End
    else
    Begin {Simple dplacement du curseur}
      fClick:=fCur; {Mmorise pour dfinition de bloc  rebrousse poil}
      If SelAvail then
      Begin
        InitZoneSel;
        AnnuleSelection;
        TraceTexte;    {Efface slection prcdente};
      End;
    End;

    If Not Focused then
      SetFocus;

    PosCurChange(False); //Recalcule fCaretX et fCaretY
  End; {Button=mbLeft}
End;

Procedure TSrcEdit.MouseMove(Shift:TShiftState; X,Y:Integer);
Var Mem:TLinCol;
Begin
  Inherited; {Appelle OnMouseMove si dfini}
  If X>fLargMarge
    then Cursor:=crIBeam
    else Cursor:=crArrow;

  If fMouseDown and (ssLeft in Shift) then
    If (Y>0) and (Y<ClientHeight) then
    Begin {Bouton gauche appuy : dfinition de la slection}
      Mem:=fCur;     {Pour voir si Caret a boug}
      InitZone(fCur.L);

      fCur.L:=Min((Y div fInterligne)+fPremLig, fCount-1);
      fCur.C:=PixelToCar(X+fPremPix-fMargeG+(fLargCar div 2), fTxt^[fCur.L].S);
      CreeSelection;

      If Not MemeCoord(fCur,Mem) then
      Begin
        PosCurChange(False);
        AgranditZone(fCur.L);
        TraceTexte;
      End;
    End
    else
    Begin
      {Boucle avec timer et ProcessMessage pour aller plus vite}
      If (Y>ClientHeight) and (fPremLig+fNbreLig<fCount) then
      Begin
        Inc(fPremLig);
        MajScrollBars;
        Paint;
      End;

      If (Y<0) and (fPremLig>0) then
      Begin
        Dec(fPremLig);
        MajScrollBars;
        Paint;
      End;
    End;
End;

Procedure TSrcEdit.MouseUp(Button:TMouseButton; Shift:TShiftState; X,Y:Integer);
Begin
  fMouseDown:=False;
End;

Procedure TSrcEdit.DblClick;
Var S:String;
Const
    Alpha=['0'..'9','A'..'Z','a'..'z','_',''..''];
Begin
  Inherited;        {Appelle OnDbleClick si dfini}
  fDbleClick:=True; {Ignorera second MouseDown}

  S:=fTxt^[fCur.L].S;
  If Not ((fCur.C>1) and (S[fCur.C-1] in Alpha) or
          (fCur.C<Length(S)) and (S[fCur.C] in Alpha)) then Exit;

  fDebSel:=fCur;
  While (fDebSel.C>1) and (S[fDebSel.C-1] in Alpha) do
    Dec(fDebSel.C);

  fFinSel:=fCur;
  While (fFinSel.C<=Length(S)) and (S[fFinSel.C] in Alpha) do
    Inc(fFinSel.C);

  InitZoneSel;
  TraceTexte;
End;


//--------------------------------------------------------------------------
// Gestion du clavier
//--------------------------------------------------------------------------

Procedure TSrcEdit.WMGetDlgCode(var Msg:TWMGetDlgCode);
Begin
  Msg.Result:=DLGC_WANTARROWS {TSrcEdit traite touches curseur}
           or DLGC_WANTCHARS  {TSrcEdit traite caractres}
           or DLGC_WANTTAB    {TSrcEdit traite tabulations}
           ;
End;

Procedure TSrcEdit.KeyDown(var Key:Word; Shift:TShiftState);
Var
    S : String;

    Procedure ChgPosCur_MajSel_Paint;
    Var Scrolled:Boolean;
    Begin
      {Ajuste position curseur et fentre}
      Scrolled:=PosCurChange(True);

      If ssShift in Shift then
      Begin
        CreeSelection;
        AgranditZone(fCur.L);
      End
      else
      Begin
        If SelAvail then
        Begin
          AgranditZone(fDebSel.L);
          AgranditZone(fFinSel.L);
          AnnuleSelection; //plus rien n'est slectionn
        End;
        fClick:=fCur;
      End;

      If Scrolled
        then Paint
        else PaintZone;
    End;

    // Bloc commun aux dplacements verticaux du curseur
    Procedure ChangeLigneCurseur(N:Integer);
    Begin
      Inc(fCur.L,N);
      If fCur.L<0 then fCur.L:=0;
      If fCur.L>=fCount then fCur.L:=fCount-1;

      if fCaretXMem=-1
        then fCaretXMem:=fCaretX
        else fCaretX:=fCaretXMem;
      fCur.C:=PixelToCar(fCaretX+fPremPix-fMargeG,fTxt^[fCur.L].S);
      ChgPosCur_MajSel_Paint;
    End;

    // Bloc commun  delete et backspace
    Procedure Supprime;
    Begin
      If SelAvail then
      Begin {Coupe ou supprime slection}
        If ssShift in Shift then
          CutToClipboard // Fait lui-mme AjInfoUndo et Paint
        else
        Begin
          If not AjInfoUndo(GetTexteSel,'',fDebSel) then Exit;
          SetTexteSel('');
          //AgranditZone(BlocSupprim ou FinPage}
          Paint;{FinEcran}
          SignaleModif; //Appelle OnChange
        End;
      End
      else
      Begin {Supprime un caractre isol}
        S:=fTxt^[fCur.L].S;
        If fCur.C>Length(S) then
        Begin {Supprime passage  la ligne}
          If fCur.L<fCount-1 then
          Begin {ce n'est pas la fin du fichier}
            If not AjInfoUndo(#13,'',fCur) then Exit;
            S:=S+fTxt^[fCur.L+1].S;
            DelLine(fCur.L+1);
            If (fCount<fPremLig+fNbreLig) and (fPremLig>0) then
             Begin
               Dec(fPremLig);
               PosCurChange(False); {??? Optimisable en DescendCurseur}
               AgranditZone(fPremLig);
             End
             else
               AgranditZone(fPremLig+fNbreLig);
          End
          else
            Exit; {EOF, Rien  supprimer}
        end
        else
        Begin {Supprime un caractre standard}
          if not AjInfoUndo(S[fCur.C],'',fCur) then Exit;
          Delete(S,fCur.C,1);
        End;
        SetLine(fCur.L, S);

        PaintZone;
        SignaleModif; //Appelle OnChange
      End;
    End;

Begin
  Inherited;  {Appelle OnKeyDown si dfini}
  If Key=0 then Exit; {Touche intgralement traite par OnKeyDown}

  InitZone(fCur.L); {Pour Zone  repeindre}

  If (ssCtrl in Shift) and (Key<256) then
    Case Key of
      VK_INSERT,Ord('C'): {Ctrl-C, Ctrl-Ins}
        CopyToClipboard;

      Ord('V'):
        PasteFromClipboard;

      Ord('X'):
        CutToClipboard;

      Ord('Y'): {Supprime la ligne sous le curseur}
      Begin
        fDebSel.L:=fCur.L; // Place marqueur en dbut de ligne  supprimer
        fDebSel.C:=1;
        If fCur.L=fCount-1 then
        Begin {Curseur dans dernire ligne}
          If fTxt^[fCur.L].S='' then
            Exit {Dernire ligne est dj vide, quitte}
          else
          Begin {Slectionne ligne seule sans CR}
            fFinsel.L:=fCur.L;
            fFinSel.C:=Length(fTxt^[fCur.L].S)+1;
          End;
        End
        else
        Begin {Curseur pas sur dernire ligne, slectionne Ligne + CR}
          fFinSel.L:=fCur.L+1;
          fFinSel.C:=1;
        End;
        if Not AjInfoUndo(GetTexteSel,'',fDebSel) then Exit;
        SetTexteSel('');
        fCur.C:=1;
        PosCurChange(True);
        PaintFinPage;
        SignaleModif; //Appelle OnChange
      End;

      Ord('Z'): Undo;
      Ord('K'): fDebCmde:='K';
      Ord('Q'): fDebCmde:='Q';

      VK_LEFT:  {va en dbut de mot/mot prcdent};
      VK_RIGHT: {va en fin de mot/mot suivant};

      VK_UP:{Ctrl-Haut : Scroll 1 ligne plus haut}
      If fPremLig>0 then
      Begin
        Dec(fPremLig);
        MajScrollBars;
        Paint;{SHIFT Vertical + peint 1 Ligne en Bas}
        PosCurChange(False);
      End;

      VK_DOWN:{Ctrl-Bas : Scroll 1 ligne plus bas}
      If fPremLig<fCount-fNbreLig then
      Begin
        Inc(fPremLig);
        MajScrollBars;
        Paint;{Shift vertical + peint 1 ligne en haut}
        PosCurChange(False);
      End;

      VK_HOME:{Ctrl-home : Dbut du document}
      Begin
        fCur.C:=1;
        fCur.L:=0;
        ChgPosCur_MajSel_Paint;
      End;

      VK_END: {Fin du document}
      Begin
        fCur.L:=fCount-1;
        fCur.C:=Length(fTxt^[fCur.L].S)+1;
        ChgPosCur_MajSel_Paint;
      End;
    end {case Ctrl-key}
  else {Pas Ctrl-xxx}
  Begin
    Case Key of
      VK_LEFT: {1 car  gauche}
      Begin
        If fCur.C>1 then
          Dec(fCur.C)
        else
          If fCur.L>0 then
          Begin
            Dec(fCur.L);
            fCur.C:=Length(fTxt^[fCur.L].S)+1;
          End
          else
            Exit; {Curseur en dbut de texte, inutile de repaindre}
        ChgPosCur_MajSel_Paint;
      End;

      VK_RIGHT: {1 car  droite}
      Begin
        If fCur.C<=Length(fTxt^[fCur.L].S) then
          Inc(fCur.C)
        else
          If fCur.L<fCount-1 then
          Begin
            Inc(fCur.L);
            fCur.C:=1;
          End
          else
            Exit; {Curseur en fin de texte, inutile de repaindre}
        ChgPosCur_MajSel_Paint;
      End;

      VK_UP: {1 ligne plus haut}
        ChangeLigneCurseur(-1);

      VK_DOWN: {1 ligne plus bas}
        ChangeLigneCurseur(1);

      VK_PRIOR: {1 page plus haut}
        ChangeLigneCurseur(-fNbreLig+1);

      VK_NEXT: {1 page plus bas}
        ChangeLigneCurseur(fNbreLig-1);

      VK_HOME: {Dbut de ligne}
      Begin
        fCur.C:=1;
        ChgPosCur_MajSel_Paint;
      End;

      VK_END: {Fin de ligne}
      Begin
        fCur.C:=Length(fTxt^[fCur.L].S)+1;
        ChgPosCur_MajSel_Paint;
      End;

      VK_INSERT: {Insertion}
        If ssShift in Shift then
          PasteFromClipboard
        else
          fInsertion:=not fInsertion;

      VK_DELETE: {Suppression}
      Begin
        If fReadOnly then Exit;
        Supprime;
      End;

      VK_BACK: {Correction avant curseur}
      Begin
        If fReadOnly or (ssAlt in Shift) then Exit;
        If fCur.C>1 then
          Dec(fCur.C)
        else
          If fCur.L>0 then
          Begin
            Dec(fCur.L);
            fCur.C:=Length(fTxt^[fCur.L].S)+1;
          End
          else
            Exit;
        //??? AgranditZone(fCur.L);
        Supprime;
        PosCurChange(True);
      end;

      VK_RETURN:
      Begin
        If fReadOnly or
           not AjInfoUndo('',#13,fCur) then Exit;
        S:=fTxt^[fCur.L].S;
        If fCur.C-1<Length(S) then
        Begin
          SetLine(fCur.L, Copy(S, 1, fCur.C-1));
          S:=Copy(S, fCur.C, Length(S));
        End
        else
          S:='';
        Inc(fCur.L);
        InsLine(fCur.L, S);
        fCur.C:=1;

        PosCurChange(True);
        PaintFinPage;
        SignaleModif; //Appelle OnChange
      End;
    End; {Case Key}

    {Pour tout mouvement curseur autre que vertical, raz mmoire position X}
    If Not (Key in [VK_UP, VK_DOWN, VK_PRIOR, VK_NEXT]) then
      fCaretXMem:=-1;
  end; {pas Ctrl}
End;

Procedure TSrcEdit.KeyPress(var Key:Char);
Var Tmp : String;
Begin
  If Assigned(OnKeyPress) then OnKeyPress(Self,Key);

  If (Key<' ') and (Key<>#9) then Exit;

  InitZone(fCur.L); {Pour ne tracer que zone intressante}

  If fDebCmde<>#0 then
  Begin
    Dec(Key,48);
    With fMarques[Byte(Key)] do
      Case fDebCmde of
      'K': If Key in [#0..#9] then
           Begin
             If (L=fCur.L) and
                (C=fCur.C)
               then L:=-1
               else fMarques[Byte(Key)]:=fCur;
             TraceMarge;
           End;
      'Q': If (Key in [#0..#9]) and (L>=0) then
           Begin
             fCur:=fMarques[Byte(Key)];
             If PosCurChange(True) then Paint;
           End;
      End;
    fDebCmde:=#0;
    Exit;
  End;

  If fReadOnly then Exit;

  If SelAvail then
  Begin {Une slection est prsente}
    If not AjInfoUndo(GetTexteSel,Key,fDebSel) then Exit;
    AgranditZone(fDebSel.L);
    AgranditZone(fFinSel.L);
    SetTexteSel(Key);
  End
  else
  Begin {Pas de slection prsente}
    Tmp:=fTxt^[fCur.L].S;
    If fInsertion then
    Begin {Insre un caractre}
      If not AjInfoUndo('',Key,fCur) then Exit;
      Insert(Key,Tmp,fCur.C)
    End
    else
    Begin {Remplace un caractre}
      If Not AjInfoUndo(Tmp[fCur.C],Key,fCur) then Exit;
      Tmp[fCur.C]:=Key;
    End;
    SetLine(fCur.L, Tmp);
    Inc(fCur.C);
  End;
  AnnuleSelection;
  If PosCurChange(True)
    then Paint       // La page a boug
    else TraceTexte; // pas de scroll

  fClick:=fCur;      // Dplace marqueur curseur pour slection
  SignaleModif;
end;


//--------------------------------------------------------------------------
// Gestion du texte
//--------------------------------------------------------------------------

Procedure TSrcEdit.SignaleModif;
Begin
  If Assigned(fOnChange) then
    fOnChange(Self);
End;

{Accs  une ligne de faon indpendante des autres}

Function TSrcEdit.GetLine(N:Integer):String;
Begin
  Result:=fTxt^[N].S;
End;

Procedure TSrcEdit.SetLine(N:Integer; Const Chaine:String);
Begin
  With fTxt^[N] do
  Begin
    S:=Chaine;
    //Include(Indic,ilModif);
  End;
End;


Procedure TSrcEdit.InsLine(N:Integer; Const Chaine:String);
Begin
  {Si pas assez de lignes disponibles, en ajoute}
  If fCount=fTaille then
  Begin
    Inc(fTaille,1000);
    ReallocMem(fTxt, fTaille*SizeOf(TInfoLigne));
  End;

  If fCount>N then
    Move(fTxt^[N], fTxt^[N+1], (fCount-N)*SizeOf(TInfoLigne));

  With fTxt^[N] do
  Begin
    Pointer(S):=Nil; //Pour empcher rfrence multiple de la String !
    S:=Chaine;  // Place le nouveau texte
    NumOrg:=-1; // Cette ligne n'existait pas dans fichier orignal
    Indic:=[];
  End;
  Inc(fCount);
End;

Procedure TSrcEdit.DelLine(N:Integer);
Begin
  If fCount=0 then Exit;

  Dec(fCount);
  Move(fTxt^[N+1], fTxt^[N],(fCount-N)*SizeOf(TInfoLigne));
End;

{Conversion d'une partie du text e en une chaine unique}
{Utilis par gestion slection, sauvegarde et chargement}

Function TSrcEdit.GetBlocTexte(LigDeb,ColDeb, LigFin,ColFin:Integer):String;
Var
    I,N : Integer;
    S   : String;
    P   : PChar;
    L   : Integer;

    Procedure CopieChaine(Ref:PChar);
    Begin
      L:=StrLen(Ref);
      if L<>0 then
      begin
        Move(Ref^, P^, L);
        Inc(P, L);
      end;
    End;

Begin
  S:=fTxt^[LigDeb].S;
  If LigDeb=LigFin then
    Result:=Copy(S, ColDeb, ColFin-ColDeb)
  else
  Begin
    {Compte place occupe par les chaines}
    N:=Length(S)-ColDeb + 2 + ColFin; //Place pour fin premire et debut dern
    For I:=LigDeb+1 to LigFin-1 do
      Inc(N, Length(fTxt^[I].S)+2);

    {Rserve la place du rsultat}
    SetString(Result, Nil, N);
    P:=PChar(Result);

    {Copie les chaines}
    CopieChaine(PChar(Copy(S,ColDeb,Length(S))));
    PWord(P)^:=$0A0D;
    Inc(P,2);

    For I:=LigDeb+1 to LigFin-1 do
    Begin
      CopieChaine(PChar(fTxt^[I].S));
      PWord(P)^:=$0A0D;
      Inc(P,2);
    End;

    CopieChaine(PChar(Copy(fTxt^[LigFin].S, 1, ColFin-1)));
  end;
End;

Procedure TSrcEdit.InsBlocTexte(VAR Lig,Col:Integer; Chaine:String);
Var
    S  : String;  // Chaine temporaire
    FL : String;  // Sauve la fin de ligne pendant insersions
    P  : PChar;   // Pointeur dans Chaine
    Deb: PChar;   // Pointeur vers un dbut de sous-chaine de Chaine

    Procedure TraiteCrLf;
    Var X:Pointer;
    Begin
      X:=P;
      if P^=#13 then Inc(P);
      if P^=#10 then Inc(P);
      If (P^=#0) and (P<>X) then
      Begin {N'ignore pas dernier CR comme le fait Borland !!!}
        Inc(Lig);
        InsLine(Lig, '');
      End;
    End;
Begin
  {Rcupre ligne initiale, garde la fin pour plus tard}
  S:=fTxt^[Lig].S;
  FL:=Copy(S, Col, Length(S)-Col+1); // FL=Fin Ligne

  P:=PChar(Chaine);
  {Ajoute premire chaine  tronon gauche}
  Deb:=P;
  While not (P^ in [#0, #10, #13]) do Inc(P);
  SetLength(S, Col-1 + P-Deb);
  Move(Deb^,S[Col], P-Deb);
  SetLine(Lig, S);
  TraiteCrLf;

  {Insre les lignes suivantes}
  While P^<>#0 do
  Begin
    Inc(Lig);
    Deb:=P;
    While not (P^ in [#0, #10, #13]) do Inc(P);
    SetString(S, Deb, P-Deb);
    InsLine(Lig, S);
    TraiteCrLf;
  End;

  S:=fTxt^[Lig].S;
  Col:=Length(S)+1;
  {Ajoute la fin de ligne rsiduelle}
  SetLine(Lig, S + FL);
End;


Function TSrcEdit.GetTexte:String;
Begin
  Result:=GetBlocTexte(0,1, fCount-1,length(fTxt^[fCount-1].S)+1);
End;

Procedure TSrcEdit.SetTexte(Chaine:String);
Var I:Integer;
Begin
  {Vide la liste actuelle}
  For I:=0 to fCount-1 do
    fTxt^[I].S:=''; // libre les chaines alloues. Ncessaire ???
  fCount:=1;
  AnnuleSelection;

  fCur.L:=0;
  fCur.C:=1;
  InsBlocTexte(fCur.L, fCur.C, Chaine);
End;


Procedure TSrcEdit.LoadFromFile(NomFich:TFileName);
Var F      : File;
    Buf    : String;
    Taille : Integer;
    I,Lus  : Integer;
Begin
  If not FileExists(NomFich) then Exit;

  {Lit le fichier dans un buffer}
  AssignFile(F, NomFich);
  Reset(F,1);
  Taille:=Filesize(F);
  SetString(Buf, Nil, Taille);
  BlockRead(F, PChar(Buf)^, Taille, Lus);
  CloseFile(F);
//  DatHeure:=DateFichier(Chemin);

  {Conversion Oem}
  If fConvDos then
    OemToChar(PChar(Buf), PChar(Buf));

  {Transfre le buffer dans la liste de lignes}
  SetTexte(Buf); // Vide Mmoire et y palce le texte

  {Numrote les lignes pour garder trace emplacement original}
  For I:=0 to fCount-1 do
    With fTxt^[I] do
    Begin
      NumOrg:=I;
      Indic:=[];
    End;

  fModified:=False;  // Le fichier n'est pas encore modifi
  fPUndo:=Nil;       // Pas encore d'action annulable
  fRetOrigin:=True;  // Peut revenir  l'tat d'origine
  Paint;
End;

Function TSrcEdit.SaveToFile(NomFich:TFileName):Boolean;
Var I,J   : Integer;
    S     : String;
    F     : File;
Begin
  {Supprime les espaces et tabs en fin de lignes}
  For I:=0 to fCount-1 do
  With fTxt^[I] do
  Begin
    J:=Length(S);
    while (J>0) and (S[J]<=' ') do Dec(J);
    SetLength(S,J);
  End;

  {Rcupre le texte en une seule chaine}
  S:=GetTexte;

  {Si besoin convertit vers caractres dos}
  If fConvDos then
    CharToOem(PChar(S),PChar(S));

  {Sauve dans le fichier}
  Try
    AssignFile(F, NomFich);
    Rewrite(F,1);
    BlockWrite(F, PChar(S)^, Length(S), I);
    CloseFile(F);
    Result:= I=Length(S);
  Except
    Result:=False;
  End;

  If Result then
  Begin
    fModified:=False;
    // DatHeure:=DateFichier(Chemin);
  End;
End;


//--------------------------------------------------------------------------
// Gestion de la slection
//--------------------------------------------------------------------------

Procedure TSrcEdit.CreeSelection;
Begin
  If (fCur.L<fClick.L) or ((fCur.L=fClick.L) and (fCur.C<fClick.C)) then
  Begin
    fDebSel:=fCur;
    fFinSel:=fClick;
  End
  else
    If MemeCoord(fCur,fClick) then
      AnnuleSelection
    else
    Begin
      fDebSel:=fClick;
      fFinSel:=fCur;
    End;
End;

Procedure TSrcEdit.AnnuleSelection;
Begin
  fDebSel:=fCur;
  fFinSel:=fCur;
End;

Function TSrcEdit.SelAvail:Boolean;
Begin
  SelAvail:={(fDebSel.L>=0) and} Not MemeCoord(fDebSel, fFinSel);
End;

Function TSrcEdit.GetSelStart:Integer;
Var I : Integer;
    M : TLinCol; // Marque de rfrence
Begin
  If SelAvail
    then M:=fDebSel
    else M:=fCur;
  Result:=M.C-1; {SelStart commence  0}
  For I:=0 to Min(M.L, fCount)-1 do
    Inc(Result, Length(fTxt^[I].S)+2); //+2 pour CR et LF
End;

Procedure TSrcEdit.SetSelStart(N:Integer);
Var I,J : Integer;
Begin
  I:=0;
  J:=Length(fTxt^[I].S);       // Rcup longueur ligne
  While (J<N) and (I<fCount-1) do
  Begin  // Le curseur n'est pas sur cette ligne
    Dec(N,J+2); // +2 pour CRLF
    Inc(I);
    J:=Length(fTxt^[I].S);
  End;

  If J>=N then
  Begin
    fDebSel.L:=I;
    fDebSel.C:=N+1;
    fCur:=fDebSel;
    PosCurChange(False);
  End;
End;

Function  TSrcEdit.GetSelLength:Integer;
Var I : integer;
Begin
  If SelAvail then
  Begin
    If fDebSel.L=fFinSel.L then
      Result:=fFinSel.C-fDebSel.C
    else
    Begin
      Result:=Length(fTxt^[fDebSel.L].S)-fDebSel.C + fFinSel.C +1;
      For I:=fDebSel.L+1 to fFinSel.L-1 do
        Inc(Result, Length(fTxt^[I].S)+1);
    End
  End
  else
    Result:=0;
End;

Procedure TSrcEdit.SetSelLength(N:Integer);
Var J:Integer;
Begin
  If N=0 then
    AnnuleSelection
  else
  Begin
    {Si pas encore de slection, positionne au curseur}
    If Not SelAvail then
      fDebSel:=fCur;

    {Calcule position fin slection}
    fFinSel:=fDebSel;
    J:=Length(fTxt^[fDebSel.L].S)-fDebSel.C+1;
    While (N>J) and (fFinSel.L<fCount-1) do
    Begin
      Dec(N,J+1);
      Inc(fFinSel.L);
      fFinSel.C:=1;
      J:=Length(fTxt^[fFinSel.L].S);
    End;
    If N<=J
      then Inc(fFinSel.C, N) // On a atteint la fin de la slection
      else fFinSel.C:=J;     // On a atteint la fin du texte
    fCur:=fFinSel;
    PosCurChange(False);
  End;
  Paint;{Juste ce qu'il faut}
End;


Function TSrcEdit.GetTexteSel:String;
Begin
  If SelAvail
    then Result:=GetBlocTexte(fDebSel.L,fDebSel.C, fFinSel.L, fFinSel.C)
    else Result:= '';
End;

Procedure TSrcEdit.SetTexteSel(const Chaine:String);
Var
    S  : String;  // Chaine temporaire
Begin
  {CoupeSelection}
  If SelAvail then
  Begin
    S:=Copy(fTxt^[fDebSel.L].S, 1, fDebSel.C-1)+
       Copy(fTxt^[fFinSel.L].S, fFinSel.C, Length(fTxt^[fFinSel.L].S));
    While fFinSel.L>fDebSel.L do
    Begin
      DelLine(fFinSel.L);
      Dec(fFinSel.L);
    End;
    SetLine(fDebSel.L, S);
    fCur:=fDebSel;
  End;

  {Place nouveau texte}
  AnnuleSelection;
  InsBlocTexte(fCur.L, fCur.C, Chaine); //Insre texte et met curseur  sa fin

  PosCurChange(True); // Montre fin du bloc
End;


//--------------------------------------------------------------------------
// Gestion des marqueurs
//--------------------------------------------------------------------------

{Une seule instance des bitmaps pour tous les diteurs ouverts}
{$R SrcEdit.res}

Procedure ChargeImagesMarques;   {Procdure globale hors objet}
Var I:Integer;
Begin
  For I:=0 to 9 do
  Begin
    Marques[I]:=TBitmap.Create;
    Marques[I].LoadFromResourceName(HInstance,'I'+Char(I+48));
  End;
End;

Procedure DetruitsImagesMarques; {Procdure globale hors objet}
Var I:Integer;
Begin
  For I:=0 to 9 do
    Marques[I].Free;
End;

{Dplace les marqueurs en fonction du texte supprim, remplac et d'o}
Procedure TSrcEdit.MajMarques(Const Ote,Rempl:String; Ou:TLinCol);
Var
  Ligs,            {Nombre de lignes  ajouter aux marques}
  Cols : Integer;  {Nombre de colones  ajouter aux marques}
  I    : Integer;  {Compteur de boucles}
Begin
  Ligs:=NbrLigCol(Rempl,Cols) - NbrLigCol(Ote,I);
  Dec(Cols,I);
  For I:=0 to 9 do
    with fMarques[I] do
      If (L>Ou.L) or ((L=Ou.L) and (C>=Ou.C)) then
      Begin
        Inc(L,Ligs);
        If (Ligs>0) and (L=Ou.L+Ligs) then
          Inc(C,Cols-Ou.C) //Ajout de lignes
        else if (Ligs<0) and (L=Ou.L) then
          Inc(C,Cols+Ou.C) //Suppression de lignes
        else if (Ligs=0) then
          Inc(C,Cols);     //Insersion de cars sans dcalages de lignes

        If (L<Ou.L) or ((L=Ou.L) and (C<Ou.C)) then
          fMarques[I]:=Ou  //Marques ne remontent jamais avant dbut du bloc}
      End;
End;


//--------------------------------------------------------------------------
// Gestion PressePapier
//--------------------------------------------------------------------------

procedure TSrcEdit.CopyToClipboard;
Begin
  If SelAvail then
    ClipBoard.SetTextBuf(PChar(GetTexteSel));
End;

procedure TSrcEdit.CutToClipboard;
Var S : String;  //Raccourci pour viter appels multiples  GetTexteSel
    N : Integer; //Pour dterminer si suppression de lignes ou non
Begin
  If fReadOnly then Exit;

  S:=GetTexteSel;
  If SelAvail and AjInfoUndo(S,'',fDebSel) then
  Begin
    ClipBoard.SetTextBuf(PChar(S));
    InitZone(fCur.L);
    N:=fCount;
    SetTexteSel('');
    If fCount=N
      then PaintZone     // Seulement la ligne modifie
      else PaintFinPage; // Toute la fin de page
    SignaleModif;
  end;
End;

procedure TSrcEdit.PasteFromClipboard;
Var S : String;
    N : Integer;
    B : Boolean;
Begin
  If fReadOnly then Exit;

  If Clipboard.HasFormat(CF_TEXT) then
  Begin
    N:=fCount; {Pour savoir si insertion de lignes}

    S:=Clipboard.AsText;
    If SelAvail
      then B:=AjInfoUndo(GetTexteSel,S,fDebSel)
      else B:=AjInfoUndo('',S,fCur);
    If Not B then Exit;

    fDebZone:=fDebSel.L; // La zone slectionne sera supprime, donc
    SetTexteSel(Clipboard.AsText);

    {Redessine la partie modifie}
    If N=fCount then
    Begin {Pas d'ajout de lignes}
      fFinZone:=fFinSel.L;
      TraceTexte;
    End
    else {Des lignes ont t ajoutes ou supprimes}
      PaintFinPage;

    SignaleModif;
  End;
End;


//--------------------------------------------------------------------------
// Gestion Undo (Ctrl-Z ou Alt-Backspace)
//--------------------------------------------------------------------------

Function TSrcEdit.AjInfoUndo(Const Ote,Rempl:String; Ou:TLinCol):Boolean;
Const SizeOfStruc=SizeOf(PInfoUndo)+SizeOf(TLinCol)+SizeOf(Integer);
Var
  P   : PInfoUndo; {pointeur temporaire pour passage}
  LAct: Integer;   {Longueur de la structure actuelle}
  LNew: Integer;   {Longueur de la structure  ajouter}
  T   : Integer;   {Temporaires}
Begin
  Result:=True; {trs probable !}

  // Vrifie qu'info  mmoriser peut entrer dans le buffer
  LNew:=SizeOfStruc+Length(Ote)+1;
  If LNew>fTailleUndo then
  Begin {Info Undo grop grande pour tenir dans buffer}
    {Undo sera impossible, demande autorisation opration}
    If Assigned(fOnRazUndo) then
      If Not fOnRazUndo(Self) then
      Begin {Utilisateur prfre abandonner modification...}
        Result:=False;
        Exit;
      End;
    fPUndo:=Nil;       {Raz Buffer Undo}
    fRetOrigin:=False; {il n'est plus possible de revenir  l'original}
    Exit;
  End;

{Concatnation entres clavier :
* frappe d'un caractre :
  - Supp='', NouvLong=1, Emplacement curseur=prcdent+1 -> Inc(NouvLong)
    remplacement -> ajouter car  chaine dtruite comme pour del

* Suppression d'un caractre
  - Length(Sup)=1,
    Del : curseur n'a pas boug -> ajouter car en fin de chaine supprime
    BS  : curseur  recul -> ajouter car en dbut de chaine supprime
                              reculer dbut d'un cran}
{ Prpare pointeur vers emplacement stockage nouvelle entre Undo}
  If fPUndo=Nil then
    P:=fPBufUndo {Aucune entre prsente, initialise P}
  else
  Begin
    LAct:=Integer(fPUndo)+SizeOfStruc+StrLen(fPUndo^.Ref)+1-Integer(fPBufUndo);
    If LAct+LNew>fTailleUndo then
    Begin {Ca ne rentre pas, te Infos plus anciennes}
      {??? Signaler qu'il ne sera plus possible de revenir  l'original}
      P:=fPBufUndo;
      Repeat
        T:=SizeOfStruc+StrLen(P^.Ref)+1; {Taille entre pointe par P}
        Inc(PChar(P),T);
        Dec(PChar(fPUndo),T);
        Dec(LAct,T);
      until LAct+LNew<fTailleUndo;
      Move(P^,fPBufUndo^,LAct);
      fRetOrigin:=False; {il n'est plus possible de revenir  l'original}
    End;
    // Avance pointeur aprs dernier octet de l'info courante
    P:=fPUndo;
    Inc(PChar(P),SizeOfStruc+StrLen(P^.Ref)+1);
  End;
  P^.Prec:=fPUndo; {Indique o commence l'entre prcdente}
  fPUndo:=P;

  With fPUndo^ do
  Begin
    Lieu:=Ou;
    Long:=Length(Rempl); {Ignore les caractre de fin de ligne}
    For T:=1 to length(Rempl)-1 do
      If Word((@Rempl[T])^)=$0A0D then
        Dec(Long);
    Move(PChar(Ote)^,Ref,Length(Ote)+1);   // +1 pour copier aussi 0 final
  End;

  // Puisque traitement AjInfoUndo, c'est que l'original va tre modifi
  fModified:=True;
  MajMarques(Ote,Rempl,Ou);
End;


Function TSrcEdit.CanUndo:Boolean;
Begin
  Result:= fPUndo<>Nil;
End;

Procedure TSrcEdit.Undo;
Begin
  If fPUndo=Nil then Exit; {Table Vide}

  {Si on annule la premire modif, remet modified  false !}
  If fPUndo=fPBufUndo then
    fModified:=Not fRetOrigin;

  {Place curseur  l'endroit modifi}
  fCur:=fPUndo^.Lieu;
  {Si caractres  dtruire, les met dans la slection}
  If fPUndo^.Long>0 then
  Begin
    fDebSel:=fCur;
    fFinSel:=fDebSel;
    While fPUndo^.Long>0 do
    Begin
      If fFinSel.C<=Length(fTxt^[fFinSel.L].S) then
        Inc(fFinSel.C)
      else
      Begin
        Inc(fFinSel.L);
        fFinSel.C:=1;
      End;
      Dec(fPUndo^.Long);
    End;
  End
  else
    AnnuleSelection; {Rien n'est  supprimer, annule slection}

  {Dplace les marqueurs}
  MajMarques(GetTexteSel, String(fPUndo^.Ref), fPUndo^.Lieu);

  {Remplace slection par chaine originale}
  SetTexteSel(String(fPUndo^.Ref));

  {Recule pointeur d'une entre}
  If fPUndo<>fPBufUndo
    then fpUndo:=fpUndo^.Prec
    else fPUndo:=NIL; {On vient de restaurer la premire modif du buffer}

  Paint;{de fDebSel  fin cran ou fin de ligne si pas CR dans slection}
  SignaleModif;
End;


//--------------------------------------------------------------------------
// Autres outils et fonctions publiques  usage externe
//--------------------------------------------------------------------------

// Caractres accepts dans traitement des mots sous curseur
Const Cars : Set Of Char =['_','0'..'9','A'..'Z','a'..'z'];

Function TSrcEdit.MotSousCurseur:String;
Var Pt  : TPoint;
    D,F : Integer;
    S   : String; {Raccourci pour viter appels multiples  fTexte.Text}
Begin
  GetCursorPos(Pt);
  Pt:=ScreenToClient(Pt);

  Result:='';
  If (Pt.X<fMargeG) or (Pt.X>Width) or (Pt.Y<0) or (Pt.Y>Height) then Exit;

  {Calcule n ligne et n colonne}
  S:=fTxt^[Min((Pt.Y div fInterligne)+fPremLig,fCount-1)].S;
  If S='' then Exit;

  D:=PixelToCar(Pt.X-fMargeG+fPremPix, S);
  F:=D;
  If (D>=0) and (S[D]>' ') then
  Begin
    While (D>0) and (S[D-1] in Cars) do Dec(D);
    While (F<=Length(S)) and (S[F] in Cars) do Inc(F);
  End;
  Result:=Copy(S,D,F-D);
End;

{Bascule minuscules/majuscule le bloc slectionn ou le caractre aprs le curseur}
Procedure TSrcEdit.MinMaj;
Var S,MemS : String;
    I      : Integer;
    NoSel  : Boolean;
    Change : Boolean;
Begin
  NoSel:= Not SelAvail;
  If NoSel then
  Begin  {Pas de slection disponible}
    If fCur.C>Length(fTxt^[fCur.L].S) then
    Begin {Curseur est en fin de ligne}
      If fCur.L=fCount-1 then Exit; {En fin de texte}
      Inc(fCur.L);
      fCur.C:=1;
    End;
    fDebSel:=fCur;
    fFinSel:=fCur;
    Inc(fFinSel.C);
  End;

  S:=GetTexteSel;             {Rcupre texte slectionn}
  MemS:=S;
  For I:=1 to Length(S) do    {change la casse}
    Case S[I] of
     'a'..'z':Dec(S[I],$20);
     'A'..'Z':Inc(S[I],$20);
    End;

  Change := MemS<>S;
  If (Change and AjInfoUndo(MemS,S,fDebSel)) or
     (Not Change and NoSel) then
    SetTexteSel(S);

  If NoSel then
  Begin {Pas de slection}
    AnnuleSelection;          {remet dbut et longueur en place}
    InitZone(fCur.L);
  End
  else
    InitZoneSel;

  PaintZone;
  If Change then
    SignaleModif;
End;

{Si la ligne N n'est pas visible, essaye de la mettre au milieu de l'cran
 puis positionne le curseur dessus}
Procedure TSrcEdit.MontreLigne(N:Integer);
Begin
  Dec(N);
  If (N<fPremLig) or (N>fPremLig+fNbreLig) then
  SetPremLig(N-fNbreLig div 3);
  fCur.L:=N;
  fCur.C:=1;
  If PosCurChange(True) then
    Paint;
End;

{
frMatchCase -> indique de tenir compte de la casse
frWholeWord -> non utilis ??? indique de ne retenir que les mots complets

frFindNext  -> indique de partir de l'emplacement trouv prcdemment
               sinon, commence  partir du dbut/fin selon frDown
frDown      -> sens de recherche

frReplace    -> une seule recherche, ignore rsultat de Proc
frReplaceAll -> toutes les recherches, ignore rsultat de Proc
frShowHelp  -> ignor
}

Function TSrcEdit.Search(Chaine:String; Options:TFindOptions; Proc:TFindProc):Boolean;
var
  S     : String;
  I,J   : Integer;
  Maj   : Boolean; {Raccourci pour viter test 'in option' multiple}
Begin
  {Si pas case sensitive, travaille sur majuscules}
  Maj:=Not (frMatchCase in Options);
  If Maj then Chaine:=UpperCase(Chaine);

  {Si slection, cherche aprs, sinon cherche depuis le dbut}
  If SelAvail
    then I:=fFinSel.L
    else I:=1;

  Result:=False; {Pas encore trouv de correspondance}
  If Assigned(Proc) then
  repeat {Excute proc pour chaque trouvaille}
    S:=fTxt^[I].S;
    If Maj then S:=UpperCase(S);

    J:=Pos(Chaine, S);
    If J>0 then
    Begin
      Result:=True;
      If Not Proc(I,J) then Break;
    End;
    Inc(I);
  until I=fCount
  else
  repeat {N'en cherche qu'un}
    S:=fTxt^[I].S;
    If Maj then S:=UpperCase(S);

    J:=Pos(Chaine, S);
    If J>0 then
    Begin
      Result:=True;
      If Not Proc(I,J) then Break;
    End;
    Inc(I);
  until (I=fCount) or (J>0);


  {  S:=Text;
  S:=Copy(S,I,Length(S)-I+1);

  If not (frMatchCase in Options) then
  Begin
    S:=UpperCase(S);
    Chaine:=UpperCase(Chaine);
  End;

  J:=Pos(Chaine,S);
  Result:=J<>0;

  If Result then
  Begin
    SetFocus;
    SelStart:=I+J-2;
    SelLength:=Length(Chaine);
  End}

End;



Initialization
  ChargeImagesMarques;
Finalization
  DetruitsImagesMarques;
end.
